﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using MSUtil;

namespace Accesses
{
    public partial class Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                GetData();


                // Set the update frequency 
                int interval;
                string intervalString = System.Configuration.ConfigurationManager.AppSettings["StatusRefreshIntervalms"];

                if (String.IsNullOrEmpty(intervalString))
                    interval = 10000;
                else
                    interval = Convert.ToInt32(intervalString); // What if it's not a number? Should be using tryparse?  
                tmrUpdateInterval.Interval = interval;
                lblIntervalLabel.Text = (interval / 1000).ToString(); // Display the value on screen - this might be removed soon
            }

        }

        protected void btnRefresh_Click(object sender, EventArgs e)
        {
            GetData();
        }

        protected void GetData()
        {
            // Get Todays date, and form the filename
            string filename = "";
            filename = "ex" + String.Format("{0:yyMMdd}", DateTime.Now) + ".log";

            Label1.Text = filename;
            // prepare LogParser Recordset & Record objects
            ILogRecordset rsLP = null;
            ILogRecord rowLP = null;

            LogQueryClass LogParser = null;
            COMW3CInputContextClass W3Clog = null;

            string strSQL = null;

            LogParser = new LogQueryClass();
            W3Clog = new COMW3CInputContextClass();

            strSQL = "select TO_DATE(QUANTIZE(TO_LOCALTIME(TO_TIMESTAMP(date, time)), 86400)) AS Day, ";
            strSQL = strSQL + "	count(*) as Hits ";
            strSQL = strSQL + " from ";
            strSQL = strSQL + " c:\\WINDOWS\\system32\\LogFiles\\W3SVC1\\" + filename + " ";
            strSQL = strSQL + " where ";
            strSQL = strSQL + " cs-uri-stem like '%search%.asp' ";
            strSQL = strSQL + " and ";
            strSQL = strSQL + " sc-status = 200 ";
            strSQL = strSQL + " group by Day ";

            int count = 0;
            try
            {
                rsLP = LogParser.Execute(strSQL, W3Clog);
                while (!rsLP.atEnd())
                {
                    rowLP = rsLP.getRecord();

                    count++;
                    lblNumSearches.Text = rowLP.getValue(1).ToString();
                    rsLP.moveNext();
                }
            }
            catch (Exception e)
            {
                throw e;
            }
            if (count == 0) // there was no data
                lblNumSearches.Text = "0 so far";
              


            // Now look for number restores

            strSQL = "select TO_DATE(QUANTIZE(TO_LOCALTIME(TO_TIMESTAMP(date, time)), 86400)) AS Day, ";
            strSQL = strSQL + "	count(*) as Hits ";
            strSQL = strSQL + " from ";
            strSQL = strSQL + " c:\\WINDOWS\\system32\\LogFiles\\W3SVC1\\" + filename + " ";
            strSQL = strSQL + " where ";
            strSQL = strSQL + " cs-uri-stem like '%restore%.asp' ";
            strSQL = strSQL + " and ";
            strSQL = strSQL + " sc-status = 200 ";
            strSQL = strSQL + " group by Day ";

            count = 0;
            try
            {
                rsLP = LogParser.Execute(strSQL, W3Clog);
                while (!rsLP.atEnd())
                {
                    rowLP = rsLP.getRecord();

                    count++;
                    lblNumRestores.Text = rowLP.getValue(1).ToString();
                    rsLP.moveNext();
                }
            }
            catch
            {
            }
            if (count == 0) // there was no data
                lblNumRestores.Text = "0 so far";


            // Now look for number of retrievals

            strSQL = "select TO_DATE(QUANTIZE(TO_LOCALTIME(TO_TIMESTAMP(date, time)), 86400)) AS Day, ";
            strSQL = strSQL + "	count(*) as Hits ";
            strSQL = strSQL + " from ";
            strSQL = strSQL + " c:\\WINDOWS\\system32\\LogFiles\\W3SVC1\\" + filename + " ";
            strSQL = strSQL + " where ";
            strSQL = strSQL + " cs-uri-stem like '%download.asp' ";
            strSQL = strSQL + " and ";
            strSQL = strSQL + " sc-status = 200 ";
            strSQL = strSQL + " group by Day ";

            count = 0;
            try
            {
                rsLP = LogParser.Execute(strSQL, W3Clog);
                while (!rsLP.atEnd())
                {
                    rowLP = rsLP.getRecord();

                    count++;
                    lblNumRetrievals.Text = rowLP.getValue(1).ToString();
                    rsLP.moveNext();
                }
            }
            catch
            {
            }
            if (count == 0) // there was no data
                lblNumRetrievals.Text = "0 so far";
        }


        protected void Timer1_Tick(object sender, EventArgs e)
        {
            GetData();
        }

    }
}